//
//  MTLTimerQueue.h
//  QueueTEst
//
//  Created by narita on 2013/05/23.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface MTLTimerQueue : NSObject
{
@protected
    NSMutableArray* _queue;
    NSTimer*        _timer;
    id              _target;
    SEL             _action;
    
    NSTimeInterval  _firstInterval;
    NSTimeInterval  _continueInterval;
}

#pragma mark -
#pragma mark class methods

+ (id) timerQueueWithTarget:(id)anObject
                     action:(SEL)aSelector
              firstInterval:(NSTimeInterval)firstTime
           continueInterval:(NSTimeInterval)continueTime;

#pragma mark -
#pragma mark init methods

// 指定イニシャライザ
- (id) initWithTarget:(id)anObject
               action:(SEL)aSelector
        firstInterval:(NSTimeInterval)firstTime
     continueInterval:(NSTimeInterval)continueTime;

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark action & canAction methods

- (id)   dequeue;
- (void) enqueue:(id)anObject;

- (NSUInteger)count;

#pragma mark -
#pragma mark delegate/datasource methods

#pragma mark -
#pragma mark accessor methods (in pairs)

@property (retain) id  target;
@property (assign) SEL action;

@property (assign) NSTimeInterval firstInterval;
@property (assign) NSTimeInterval continueInterval;

#pragma mark -
#pragma mark Utility methods

@end
